Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/GTAlgorithmUtils.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/GTAlgorithmUtils.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/GTAlgorithmUtils.cs	(revision 13437)
@@ -0,0 +1,80 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  public static class GTAlgorithmUtils {
+
+    public static ItemList<Task> GetEarliestNotScheduledTasks(IEnumerable<Job> jobData) {
+      ItemList<Task> result = new ItemList<Task>();
+      foreach (Job j in jobData) {
+        foreach (Task t in j.Tasks) {
+          if (!t.IsScheduled) {
+            result.Add(t);
+            break;
+          }
+        }
+      }
+      return result;
+    }
+    public static Task GetTaskWithMinimalEC(IEnumerable<Task> earliestTasksList, Schedule schedule) {
+      double minEct = double.MaxValue;
+      Task result = null;
+      foreach (Task t in earliestTasksList) {
+        double ect = ComputeEarliestCompletionTime(t, schedule);
+        if (ect < minEct) {
+          result = t;
+          minEct = ect;
+        }
+      }
+      return result;
+    }
+    public static ItemList<Task> GetConflictSetForTask(Task conflictedTask, IEnumerable<Task> earliestTasksList, Schedule schedule) {
+      ItemList<Task> result = new ItemList<Task>();
+      double conflictedCompletionTime = ComputeEarliestCompletionTime(conflictedTask, schedule);
+      result.Add(conflictedTask);
+      foreach (Task t in earliestTasksList) {
+        if (t.ResourceNr == conflictedTask.ResourceNr) {
+          if (ComputeEarliestStartTime(t, schedule) < conflictedCompletionTime)
+            result.Add(t);
+        }
+      }
+      return result;
+    }
+
+    public static double ComputeEarliestStartTime(Task t, Schedule schedule) {
+      ScheduledTask previousTask = schedule.GetLastScheduledTaskForJobNr(t.JobNr);
+      Resource affectedResource = schedule.Resources[t.ResourceNr];
+      double lastMachineEndTime = affectedResource.TotalDuration;
+      double previousJobTaskEndTime = 0;
+      if (previousTask != null)
+        previousJobTaskEndTime = previousTask.EndTime;
+
+      return Math.Max(previousJobTaskEndTime, lastMachineEndTime);
+    }
+    private static double ComputeEarliestCompletionTime(Task t, Schedule schedule) {
+      return ComputeEarliestStartTime(t, schedule) + t.Duration;
+    }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj	(revision 13437)
@@ -123,4 +123,5 @@
     <Compile Include="Interfaces\IScheduleCrossover.cs" />
     <Compile Include="Interfaces\ISchedule.cs" />
+    <Compile Include="Interfaces\IScheduleEncoding.cs" />
     <Compile Include="Interfaces\IScheduleManipulator.cs" />
     <Compile Include="Interfaces\IScheduleOperator.cs" />
@@ -129,4 +130,5 @@
     <Compile Include="JobSequenceMatrix\Crossovers\JSMOXCrossover.cs" />
     <Compile Include="JobSequenceMatrix\Crossovers\JSMSXXCrossover.cs" />
+    <Compile Include="JobSequenceMatrix\JobSequenceMatrixEncoding.cs" />
     <Compile Include="JobSequenceMatrix\JSMEncoding.cs" />
     <Compile Include="JobSequenceMatrix\JSMRandomCreator.cs" />
@@ -139,4 +141,5 @@
     <Compile Include="PermutationWithRepetition\Manipulators\PWRManipulator.cs" />
     <Compile Include="PermutationWithRepetition\Manipulators\PWRInsertionManipulator.cs" />
+    <Compile Include="PermutationWithRepetition\PermutationWithRepetitionEncoding.cs" />
     <Compile Include="PermutationWithRepetition\PWREncoding.cs" />
     <Compile Include="PermutationWithRepetition\PWRRandomCreator.cs" />
@@ -147,11 +150,14 @@
     <Compile Include="PriorityRulesVector\Manipulators\PRVManipulator.cs" />
     <Compile Include="PriorityRulesVector\Manipulators\PRVUniformOnePositionManipulator.cs" />
+    <Compile Include="PriorityRulesVector\PriorityRulesVectorEncoding.cs" />
     <Compile Include="PriorityRulesVector\PRVEncoding.cs" />
     <Compile Include="PriorityRulesVector\PRVRandomCreator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="ScheduleEncoding.cs" />
     <Compile Include="ScheduleEncoding\Crossovers\DirectScheduleCrossover.cs" />
     <Compile Include="ScheduleEncoding\Crossovers\DirectScheduleGTCrossover.cs" />
-    <Compile Include="ScheduleEncoding\GTAlgorithmUtils.cs" />
-    <Compile Include="ScheduleEncoding\Job.cs" />
+    <Compile Include="GTAlgorithmUtils.cs" />
+    <Compile Include="Job.cs" />
+    <Compile Include="ScheduleEncoding\DirectScheduleEncoding.cs" />
     <Compile Include="ScheduleEncoding\Manipulators\DirectScheduleManipulator.cs" />
     <Compile Include="ScheduleEncoding\DirectScheduleRandomCreator.cs" />
@@ -161,5 +167,5 @@
     <Compile Include="ScheduleCreator.cs" />
     <Compile Include="ScheduleCrossover.cs" />
-    <Compile Include="ScheduleEncoding\Task.cs" />
+    <Compile Include="Task.cs" />
     <Compile Include="ScheduleManipulator.cs" />
   </ItemGroup>
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IDirectScheduleOperator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IDirectScheduleOperator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IDirectScheduleOperator.cs	(revision 13437)
@@ -24,4 +24,5 @@
 namespace HeuristicLab.Encodings.ScheduleEncoding {
   public interface IDirectScheduleOperator : IOperator {
+    ILookupParameter<ItemList<Job>> JobDataParameter { get; }
   }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/ISchedule.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/ISchedule.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/ISchedule.cs	(revision 13437)
@@ -20,8 +20,8 @@
 #endregion
 
-using HeuristicLab.Core;
+using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
-  public interface ISchedule : IItem {
+  public interface ISchedule : ISolution {
   }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs	(revision 13437)
@@ -21,9 +21,12 @@
 
 using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
-  public interface IScheduleCreator : ISolutionCreator, IScheduleOperator {
+  public interface IScheduleCreator : ISolutionCreator<ISchedule>, IScheduleOperator {
     ILookupParameter<ISchedule> ScheduleParameter { get; }
+    IValueLookupParameter<IntValue> JobsParameter { get; }
+    IValueLookupParameter<IntValue> ResourcesParameter { get; }
   }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleEncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleEncoding.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleEncoding.cs	(revision 13437)
@@ -0,0 +1,39 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  public interface IScheduleEncoding : IEncoding<ISchedule> {
+    IFixedValueParameter<ItemList<Job>> JobDataParameter { get; set; }
+    IFixedValueParameter<IntValue> JobsParameter { get; set; }
+    IFixedValueParameter<IntValue> ResourcesParameter { get; set; }
+
+    ItemList<Job> JobData { get; }
+    int Jobs { get; set; }
+    int Resources { get; set; }
+
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Job.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Job.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Job.cs	(revision 13437)
@@ -0,0 +1,160 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.ComponentModel;
+using System.Text;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("Job", "Represents a composition of tasks that require processing in a scheduling problem.")]
+  [StorableClass]
+  public sealed class Job : Item, INotifyPropertyChanged {
+
+    [Storable(Name = "DueDate")]
+    private double dueDate;
+    public double DueDate {
+      get { return dueDate; }
+      set {
+        if (dueDate == value) return;
+        dueDate = value;
+        OnPropertyChanged("DueDate");
+        OnToStringChanged();
+      }
+    }
+
+    [Storable(Name = "Index")]
+    private int index;
+    public int Index {
+      get { return index; }
+      set {
+        if (index == value) return;
+        index = value;
+        OnPropertyChanged("Index");
+        OnToStringChanged();
+      }
+    }
+
+    [Storable(Name = "Tasks")]
+    private ItemList<Task> tasks;
+    public ItemList<Task> Tasks {
+      get { return tasks; }
+      private set {
+        tasks = value;
+        OnPropertyChanged("Tasks");
+      }
+    }
+
+    [StorableConstructor]
+    private Job(bool deserializing) : base(deserializing) { }
+    private Job(Job original, Cloner cloner)
+      : base(original, cloner) {
+      this.dueDate = original.DueDate;
+      this.index = original.Index;
+      this.tasks = cloner.Clone(original.Tasks);
+      RegisterEventHandlers();
+    }
+    public Job() : this(-1, double.MaxValue) { }
+    public Job(int index, double dueDate)
+      : base() {
+      this.dueDate = dueDate;
+      this.index = index;
+      this.tasks = new ItemList<Task>();
+      RegisterEventHandlers();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Job(this, cloner);
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEventHandlers();
+    }
+
+    private void RegisterEventHandlers() {
+      Tasks.ItemsAdded += TasksOnItemsChanged;
+      Tasks.ItemsRemoved += TasksOnItemsRemoved;
+      Tasks.ItemsReplaced += TasksOnItemsChanged;
+      Tasks.CollectionReset += TasksOnItemsChanged;
+      foreach (var task in Tasks) {
+        task.PropertyChanged += TaskOnPropertyChanged;
+        task.ToStringChanged += TaskOnToStringChanged;
+      }
+    }
+
+    private void TasksOnItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<Task>> e) {
+      foreach (var task in e.OldItems) {
+        task.Value.PropertyChanged -= TaskOnPropertyChanged;
+        task.Value.ToStringChanged -= TaskOnToStringChanged;
+      }
+      foreach (var task in e.Items) {
+        task.Value.PropertyChanged += TaskOnPropertyChanged;
+        task.Value.ToStringChanged += TaskOnToStringChanged;
+      }
+      OnTasksChanged();
+      OnToStringChanged();
+    }
+
+    private void TasksOnItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<Task>> e) {
+      foreach (var task in e.Items) {
+        task.Value.PropertyChanged -= TaskOnPropertyChanged;
+        task.Value.ToStringChanged -= TaskOnToStringChanged;
+      }
+      OnTasksChanged();
+      OnToStringChanged();
+    }
+
+    private void TaskOnPropertyChanged(object sender, EventArgs e) {
+      OnTasksChanged();
+    }
+
+    private void TaskOnToStringChanged(object sender, EventArgs e) {
+      OnToStringChanged();
+    }
+
+    public override string ToString() {
+      var sb = new StringBuilder();
+      sb.Append("Job#" + Index + " [ ");
+      foreach (Task t in Tasks) {
+        sb.Append(t + " ");
+      }
+      sb.Append("{" + DueDate + "} ");
+      sb.Append("]");
+      return sb.ToString();
+    }
+
+    public event EventHandler TasksChanged;
+    private void OnTasksChanged() {
+      var handler = TasksChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event PropertyChangedEventHandler PropertyChanged;
+    private void OnPropertyChanged(string propertyName) {
+      var handler = PropertyChanged;
+      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
+    }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 13437)
@@ -24,5 +24,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JSMCrossover", "An operator which crosses two JSM representations.")]
   [StorableClass]
@@ -32,9 +32,6 @@
     protected JSMCrossover(bool deserializing) : base(deserializing) { }
     protected JSMCrossover(JSMCrossover original, Cloner cloner) : base(original, cloner) { }
-    public JSMCrossover()
-      : base() {
-      ParentsParameter.ActualName = "JobSequenceMatrix";
-      ChildParameter.ActualName = "JobSequenceMatrix";
-    }
+
+    public JSMCrossover() : base() { }
 
     public abstract JSMEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2);
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 13437)
@@ -26,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JSMJobbasedOrderCrossover", "Represents a crossover operation swapping subsequences of the parents to generate offspring.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs	(revision 13437)
@@ -24,5 +24,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JSMOrderCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JSMSubsequenceExchangeCrossover", "Represents a crossover operation identifiying and exchanging equal subsequences of the parents to generate offspring.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMEncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMEncoding.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMEncoding.cs	(revision 13437)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Text;
 using HeuristicLab.Common;
@@ -27,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JobSequenceMatrixEncoding", "Represents an encoding for a scheduling Problem using a list of job sequences to deliver scheduleinformation.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs	(revision 13437)
@@ -22,5 +22,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
@@ -28,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JobSequenceMatrixCreator", "Creator class used to create Job Sequence Matrix solutions for standard JobShop scheduling problems.")]
   [StorableClass]
@@ -35,10 +34,4 @@
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public IValueLookupParameter<IntValue> JobsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
-    }
-    public IValueLookupParameter<IntValue> ResourcesParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
     }
 
@@ -49,8 +42,4 @@
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
-
-      ScheduleParameter.ActualName = "JobSequenceMatrix";
     }
 
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JobSequenceMatrixEncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JobSequenceMatrixEncoding.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JobSequenceMatrixEncoding.cs	(revision 13437)
@@ -0,0 +1,68 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.Schedule {
+  [StorableClass]
+  public sealed class JobSequenceMatrixEncoding : ScheduleEncoding {
+    [StorableConstructor]
+    private JobSequenceMatrixEncoding(bool deserializing) : base(deserializing) { }
+    private JobSequenceMatrixEncoding(JobSequenceMatrixEncoding original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JobSequenceMatrixEncoding(this, cloner);
+    }
+
+    public JobSequenceMatrixEncoding()
+      : base() {
+      SolutionCreator = new JSMRandomCreator();
+      DiscoverOperators();
+    }
+
+    #region Operator Discovery
+    private static readonly IEnumerable<Type> encodingSpecificOperatorTypes;
+    static JobSequenceMatrixEncoding() {
+      encodingSpecificOperatorTypes = new List<Type>() {
+          typeof (IJSMOperator)
+      };
+    }
+    private void DiscoverOperators() {
+      var assembly = typeof(IDirectScheduleOperator).Assembly;
+      var discoveredTypes = ApplicationManager.Manager.GetTypes(encodingSpecificOperatorTypes, assembly, true, false, false);
+      var operators = discoveredTypes.Select(t => (IOperator)Activator.CreateInstance(t));
+      var newOperators = operators.Except(Operators, new TypeEqualityComparer<IOperator>()).ToList();
+
+      ConfigureOperators(newOperators);
+      foreach (var @operator in newOperators)
+        AddOperator(@operator);
+    }
+    #endregion
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JSMManipulator", "An operator which manipulates a JSM representation.")]
   [StorableClass]
@@ -32,8 +32,5 @@
     protected JSMManipulator(bool deserializing) : base(deserializing) { }
     protected JSMManipulator(JSMManipulator original, Cloner cloner) : base(original, cloner) { }
-    public JSMManipulator()
-      : base() {
-      ScheduleParameter.ActualName = "JobSequenceMatrix";
-    }
+    public JSMManipulator() : base() { }
 
     protected abstract void Manipulate(IRandom random, ISchedule individual);
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs	(revision 13437)
@@ -28,5 +28,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JSMShiftChangeManipulator", "Represents a manipulation operation where the operations of a randomly determined job are shifted in one direction for all resources.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 13437)
@@ -26,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("JSMSwapManipulator", "Represents a manipulation operation swapping parts of the individual.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 13437)
@@ -24,5 +24,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PWRCrossover", "An operator which crosses two JSM representations.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 13437)
@@ -27,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PWRGeneralizationOrderCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 13437)
@@ -27,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PWRPPXCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs	(revision 13437)
@@ -27,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PWRInsertionManipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
   [StorableClass]
@@ -43,5 +43,5 @@
       int cutIndex = random.Next(individual.PermutationWithRepetition.Length);
       int insertIndex = random.Next(individual.PermutationWithRepetition.Length);
-      List<int> perm = ((IntegerVector)(individual.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> perm = ((IntegerVector)(individual.PermutationWithRepetition.Clone())).ToList();
       int aux = perm[cutIndex];
       if (cutIndex > insertIndex) {
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PWRManipulator", "An operator which manipulates a PWR representation.")]
   [StorableClass]
@@ -33,8 +33,5 @@
     protected PWRManipulator(bool deserializing) : base(deserializing) { }
     protected PWRManipulator(PWRManipulator original, Cloner cloner) : base(original, cloner) { }
-    public PWRManipulator()
-      : base() {
-      ScheduleParameter.ActualName = "PermutationWithRepetition";
-    }
+    public PWRManipulator() : base() { }
 
     protected abstract void Manipulate(IRandom random, PWREncoding individual);
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWREncoding.cs	(revision 13437)
@@ -26,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PermutationWithRepetitionEncoding", "Represents a encoding for a standard JobShop Scheduling Problem.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 13437)
@@ -22,10 +22,9 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PermutationWithRepetitionRandomCreator", "Creates PWR-individuals at random.")]
   [StorableClass]
@@ -34,10 +33,4 @@
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public IValueLookupParameter<IntValue> JobsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
-    }
-    public IValueLookupParameter<IntValue> ResourcesParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
     }
 
@@ -48,8 +41,4 @@
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
-
-      ScheduleParameter.ActualName = "PermutationWithRepetition";
     }
 
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs	(revision 13437)
@@ -0,0 +1,68 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.Schedule {
+  [StorableClass]
+  public sealed class PermutationWithRepetitionEncoding : ScheduleEncoding {
+    [StorableConstructor]
+    private PermutationWithRepetitionEncoding(bool deserializing) : base(deserializing) { }
+    private PermutationWithRepetitionEncoding(PermutationWithRepetitionEncoding original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationWithRepetitionEncoding(this, cloner);
+    }
+
+    public PermutationWithRepetitionEncoding()
+      : base() {
+      SolutionCreator = new PWRRandomCreator();
+      DiscoverOperators();
+    }
+
+    #region Operator Discovery
+    private static readonly IEnumerable<Type> encodingSpecificOperatorTypes;
+    static PermutationWithRepetitionEncoding() {
+      encodingSpecificOperatorTypes = new List<Type>() {
+          typeof (IPWROperator)
+      };
+    }
+    private void DiscoverOperators() {
+      var assembly = typeof(IDirectScheduleOperator).Assembly;
+      var discoveredTypes = ApplicationManager.Manager.GetTypes(encodingSpecificOperatorTypes, assembly, true, false, false);
+      var operators = discoveredTypes.Select(t => (IOperator)Activator.CreateInstance(t));
+      var newOperators = operators.Except(Operators, new TypeEqualityComparer<IOperator>()).ToList();
+
+      ConfigureOperators(newOperators);
+      foreach (var @operator in newOperators)
+        AddOperator(@operator);
+    }
+    #endregion
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 13437)
@@ -24,5 +24,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVCrossover", "An operator which crosses two PRV representations.")]
   [StorableClass]
@@ -32,9 +32,5 @@
     protected PRVCrossover(bool deserializing) : base(deserializing) { }
     protected PRVCrossover(PRVCrossover original, Cloner cloner) : base(original, cloner) { }
-    public PRVCrossover()
-      : base() {
-      ParentsParameter.ActualName = "PriorityRulesVector";
-      ChildParameter.ActualName = "PriorityRulesVector";
-    }
+    public PRVCrossover() : base() { }
 
     public abstract PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2);
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVDiscreteCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVSinglePointCrossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
   [StorableClass]
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 13437)
@@ -25,5 +25,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVManipulator", "An operator which manipulates a PRV representation.")]
   [StorableClass]
@@ -32,8 +32,5 @@
     protected PRVManipulator(bool deserializing) : base(deserializing) { }
     protected PRVManipulator(PRVManipulator original, Cloner cloner) : base(original, cloner) { }
-    public PRVManipulator()
-      : base() {
-      ScheduleParameter.ActualName = "PriorityRulesVector";
-    }
+    public PRVManipulator() : base() { }
 
     protected abstract void Manipulate(IRandom random, PRVEncoding individual);
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs	(revision 13437)
@@ -26,5 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PRVUniformOnePositionManipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
   [StorableClass]
@@ -41,5 +41,5 @@
 
     public static void Apply(IRandom random, PRVEncoding individual) {
-      UniformOnePositionManipulator.Apply(random, individual.PriorityRulesVector, new IntMatrix(new int[,] { { 0, individual.NrOfRules.Value } }));
+      UniformOnePositionManipulator.Apply(random, individual.PriorityRulesVector, new IntMatrix(new int[,] { { 0, individual.NrOfRules } }));
     }
 
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVEncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVEncoding.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVEncoding.cs	(revision 13437)
@@ -23,9 +23,8 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PriorityRulesVectorEncoding", "Represents an encoding for a Scheduling Problem.")]
   [StorableClass]
@@ -35,10 +34,5 @@
 
     [Storable]
-    private IntValue nrOfRules;
-    public IntValue NrOfRules {
-      get {
-        return nrOfRules;
-      }
-    }
+    public int NrOfRules { get; private set; }
 
     [StorableConstructor]
@@ -46,20 +40,20 @@
     protected PRVEncoding(PRVEncoding original, Cloner cloner)
       : base(original, cloner) {
-      this.nrOfRules = cloner.Clone(original.NrOfRules);
+      this.NrOfRules = original.NrOfRules;
       this.PriorityRulesVector = cloner.Clone(original.PriorityRulesVector);
     }
     public PRVEncoding(int nrOfRules)
       : base() {
-      this.nrOfRules = new IntValue(nrOfRules);
+      this.NrOfRules = nrOfRules;
       this.PriorityRulesVector = new IntegerVector();
     }
-    public PRVEncoding(IntegerVector iv, IntValue nrOfRules)
+    public PRVEncoding(IntegerVector iv, int nrOfRules)
       : base() {
-      this.nrOfRules = (IntValue)nrOfRules.Clone();
+      this.NrOfRules = nrOfRules;
       this.PriorityRulesVector = (IntegerVector)iv.Clone();
     }
-    public PRVEncoding(int length, IRandom random, int min, int max, IntValue nrOfRules)
+    public PRVEncoding(int length, IRandom random, int min, int max, int nrOfRules)
       : base() {
-      this.nrOfRules = (IntValue)nrOfRules.Clone();
+      this.NrOfRules = nrOfRules;
       this.PriorityRulesVector = new IntegerVector(length, random, min, max);
     }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs	(revision 13437)
@@ -22,10 +22,9 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
+namespace HeuristicLab.Encodings.ScheduleEncoding {
   [Item("PriorityRulesRandomCreator", "Creator class used to create PRV encoding objects for scheduling problems.")]
   [StorableClass]
@@ -33,14 +32,8 @@
 
     [Storable]
-    public IntValue NrOfRules { get; set; }
+    public int NrOfRules { get; set; }
 
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public IValueLookupParameter<IntValue> JobsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
-    }
-    public IValueLookupParameter<IntValue> ResourcesParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
     }
 
@@ -49,21 +42,18 @@
     protected PRVRandomCreator(PRVRandomCreator original, Cloner cloner)
       : base(original, cloner) {
-      this.NrOfRules = cloner.Clone(original.NrOfRules);
+      this.NrOfRules = original.NrOfRules;
     }
-    public PRVRandomCreator()
-      : base() {
-      NrOfRules = new IntValue(10);
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
-      ScheduleParameter.ActualName = "PriorityRulesVector";
-    }
-
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PRVRandomCreator(this, cloner);
     }
 
-    public static PRVEncoding Apply(int jobs, int resources, IRandom random, IntValue nrOfRules) {
-      return new PRVEncoding(jobs * resources, random, 0, nrOfRules.Value, nrOfRules);
+    public PRVRandomCreator()
+      : base() {
+      NrOfRules = 10;
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
+    }
+
+    public static PRVEncoding Apply(int jobs, int resources, IRandom random, int nrOfRules) {
+      return new PRVEncoding(jobs * resources, random, 0, nrOfRules, nrOfRules);
     }
 
@@ -71,6 +61,4 @@
       return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue, NrOfRules);
     }
-
-
   }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs	(revision 13437)
@@ -0,0 +1,68 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.Schedule {
+  [StorableClass]
+  public sealed class PriorityRulesVectorEncoding : ScheduleEncoding {
+    [StorableConstructor]
+    private PriorityRulesVectorEncoding(bool deserializing) : base(deserializing) { }
+    private PriorityRulesVectorEncoding(PriorityRulesVectorEncoding original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PriorityRulesVectorEncoding(this, cloner);
+    }
+
+    public PriorityRulesVectorEncoding()
+      : base() {
+      SolutionCreator = new PRVRandomCreator();
+      DiscoverOperators();
+    }
+
+    #region Operator Discovery
+    private static readonly IEnumerable<Type> encodingSpecificOperatorTypes;
+    static PriorityRulesVectorEncoding() {
+      encodingSpecificOperatorTypes = new List<Type>() {
+          typeof (IPRVOperator)
+      };
+    }
+    private void DiscoverOperators() {
+      var assembly = typeof(IDirectScheduleOperator).Assembly;
+      var discoveredTypes = ApplicationManager.Manager.GetTypes(encodingSpecificOperatorTypes, assembly, true, false, false);
+      var operators = discoveredTypes.Select(t => (IOperator)Activator.CreateInstance(t));
+      var newOperators = operators.Except(Operators, new TypeEqualityComparer<IOperator>()).ToList();
+
+      ConfigureOperators(newOperators);
+      foreach (var @operator in newOperators)
+        AddOperator(@operator);
+    }
+    #endregion
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs	(revision 13437)
@@ -22,4 +22,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Operators;
 using HeuristicLab.Parameters;
@@ -34,4 +35,10 @@
       get { return (ILookupParameter<ISchedule>)Parameters["Schedule"]; }
     }
+    public IValueLookupParameter<IntValue> JobsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
+    }
+    public IValueLookupParameter<IntValue> ResourcesParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
+    }
 
     [StorableConstructor]
@@ -40,5 +47,7 @@
     public ScheduleCreator()
       : base() {
-      Parameters.Add(new LookupParameter<ISchedule>("Schedule", "The new scheduling solutioncandidate."));
+      Parameters.Add(new LookupParameter<ISchedule>("Schedule", "The new scheduling solution candidate."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
     }
 
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding.cs	(revision 13437)
@@ -0,0 +1,159 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.Schedule {
+  [StorableClass]
+  public abstract class ScheduleEncoding : Encoding<ISchedule>, IScheduleEncoding {
+    #region Encoding Parameters
+    [Storable]
+    private IFixedValueParameter<ItemList<Job>> jobDataParameter;
+    public IFixedValueParameter<ItemList<Job>> JobDataParameter {
+      get { return jobDataParameter; }
+      set {
+        if (value == null) throw new ArgumentNullException("JobData parameter must not be null.");
+        if (value.Value == null) throw new ArgumentNullException("JobData parameter value must not be null.");
+        if (jobDataParameter == value) return;
+
+        if (jobDataParameter != null) Parameters.Remove(jobDataParameter);
+        jobDataParameter = value;
+        Parameters.Add(jobDataParameter);
+        OnJobDataParameterChanged();
+      }
+    }
+
+    [Storable]
+    private IFixedValueParameter<IntValue> jobsParameter;
+    public IFixedValueParameter<IntValue> JobsParameter {
+      get { return jobsParameter; }
+      set {
+        if (value == null) throw new ArgumentNullException("Jobs parameter must not be null.");
+        if (value.Value == null) throw new ArgumentNullException("Jobs parameter value must not be null.");
+        if (jobsParameter == value) return;
+
+        if (jobsParameter != null) Parameters.Remove(jobsParameter);
+        jobsParameter = value;
+        Parameters.Add(jobsParameter);
+        OnJobsParameterChanged();
+      }
+    }
+    [Storable]
+    private IFixedValueParameter<IntValue> resourcesParameter;
+    public IFixedValueParameter<IntValue> ResourcesParameter {
+      get { return resourcesParameter; }
+      set {
+        if (value == null) throw new ArgumentNullException("Resources parameter must not be null.");
+        if (value.Value == null) throw new ArgumentNullException("Resources parameter value must not be null.");
+        if (resourcesParameter == value) return;
+
+        if (resourcesParameter != null) Parameters.Remove(resourcesParameter);
+        resourcesParameter = value;
+        Parameters.Add(resourcesParameter);
+        OnBoundsParameterChanged();
+      }
+    }
+    #endregion
+
+    public ItemList<Job> JobData {
+      get { return JobDataParameter.Value; }
+    }
+    public int Jobs {
+      get { return JobsParameter.Value.Value; }
+      set { JobsParameter.Value.Value = value; }
+    }
+    public int Resources {
+      get { return ResourcesParameter.Value.Value; }
+      set { ResourcesParameter.Value.Value = value; }
+    }
+
+
+    [StorableConstructor]
+    protected ScheduleEncoding(bool deserializing) : base(deserializing) { }
+    protected ScheduleEncoding(ScheduleEncoding original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    protected ScheduleEncoding() : this("Schedule") { }
+    protected ScheduleEncoding(string name) : this(name, Enumerable.Empty<Job>()) { }
+    protected ScheduleEncoding(string name, IEnumerable<Job> jobData)
+      : base(name) {
+      int jobs = jobData.Count();
+      int resources = jobData.SelectMany(j => j.Tasks).Select(t => t.ResourceNr).Distinct().Count();
+
+      jobDataParameter = new FixedValueParameter<ItemList<Job>>(Name + ".JobData", new ItemList<Job>(jobData));
+      jobsParameter = new FixedValueParameter<IntValue>(Name + ".Jobs", new IntValue(jobs));
+      resourcesParameter = new FixedValueParameter<IntValue>(Name + ".Resources", new IntValue(resources));
+
+      Parameters.Add(jobDataParameter);
+      Parameters.Add(jobsParameter);
+      Parameters.Add(resourcesParameter);
+    }
+
+    private void OnJobDataParameterChanged() {
+      ConfigureOperators(Operators);
+    }
+    private void OnJobsParameterChanged() {
+      ConfigureOperators(Operators);
+    }
+    private void OnBoundsParameterChanged() {
+      ConfigureOperators(Operators);
+    }
+
+
+    public override void ConfigureOperators(IEnumerable<IItem> operators) {
+      ConfigureCreators(operators.OfType<IScheduleCreator>());
+      ConfigureCrossovers(operators.OfType<IScheduleCrossover>());
+      ConfigureManipulators(operators.OfType<IScheduleManipulator>());
+    }
+
+    private void ConfigureCreators(IEnumerable<IScheduleCreator> creators) {
+      foreach (var creator in creators) {
+        creator.ScheduleParameter.ActualName = Name;
+        creator.JobsParameter.ActualName = JobsParameter.Name;
+        creator.ResourcesParameter.ActualName = ResourcesParameter.Name;
+      }
+    }
+
+    private void ConfigureCrossovers(IEnumerable<IScheduleCrossover> crossovers) {
+      foreach (var crossover in crossovers) {
+        crossover.ChildParameter.ActualName = Name;
+        crossover.ParentsParameter.ActualName = Name;
+      }
+    }
+
+    private void ConfigureManipulators(IEnumerable<IScheduleManipulator> manipulators) {
+      foreach (var manipulator in manipulators)
+        manipulator.ScheduleParameter.ActualName = Name;
+    }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleCrossover.cs	(revision 13437)
@@ -29,4 +29,8 @@
   [StorableClass]
   public abstract class DirectScheduleCrossover : ScheduleCrossover, IDirectScheduleOperator {
+    public ILookupParameter<ItemList<Job>> JobDataParameter {
+      get { return (LookupParameter<ItemList<Job>>)Parameters["JobData"]; }
+    }
+
     [StorableConstructor]
     protected DirectScheduleCrossover(bool deserializing) : base(deserializing) { }
@@ -34,11 +38,5 @@
     public DirectScheduleCrossover()
       : base() {
-      ParentsParameter.ActualName = "Schedule";
-      ChildParameter.ActualName = "Schedule";
       Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Job data taken from the JSSP - Instance."));
-    }
-
-    public ILookupParameter<ItemList<Job>> JobDataParameter {
-      get { return (LookupParameter<ItemList<Job>>)Parameters["JobData"]; }
     }
 
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleGTCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleGTCrossover.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleGTCrossover.cs	(revision 13437)
@@ -64,11 +64,9 @@
         Task minimal = GTAlgorithmUtils.GetTaskWithMinimalEC(earliestTasksList, child);
         int conflictedResourceNr = minimal.ResourceNr;
-        Resource conflictedResource = child.Resources[conflictedResourceNr];
 
         //STEP 2 - Compute a conflict set of all operations that can be scheduled on the conflicted resource
-        ItemList<Task> conflictSet = GTAlgorithmUtils.GetConflictSetForTask(minimal, earliestTasksList, jobData, child);
+        ItemList<Task> conflictSet = GTAlgorithmUtils.GetConflictSetForTask(minimal, earliestTasksList, child);
 
         //STEP 3 - Select a task from the conflict set
-        int progressOnResource = conflictedResource.Tasks.Count;
         Task selectedTask = null;
         if (random.NextDouble() < mutProp) {
@@ -77,5 +75,5 @@
         } else {
           //Crossover
-          selectedTask = SelectTaskFromConflictSet(conflictSet, ((random.Next(2) == 0) ? parent1 : parent2), conflictedResourceNr, progressOnResource);
+          selectedTask = SelectTaskFromConflictSet(conflictSet, ((random.Next(2) == 0) ? parent1 : parent2), conflictedResourceNr);
         }
 
@@ -92,5 +90,5 @@
     }
 
-    private static Task SelectTaskFromConflictSet(ItemList<Task> conflictSet, Schedule usedParent, int conflictedResourceNr, int progressOnResource) {
+    private static Task SelectTaskFromConflictSet(ItemList<Task> conflictSet, Schedule usedParent, int conflictedResourceNr) {
       //Apply Crossover
       foreach (ScheduledTask st in usedParent.Resources[conflictedResourceNr].Tasks) {
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleEncoding.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleEncoding.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleEncoding.cs	(revision 13437)
@@ -0,0 +1,78 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.Schedule {
+  [StorableClass]
+  public sealed class DirectScheduleEncoding : ScheduleEncoding {
+    [StorableConstructor]
+    private DirectScheduleEncoding(bool deserializing) : base(deserializing) { }
+    private DirectScheduleEncoding(DirectScheduleEncoding original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DirectScheduleEncoding(this, cloner);
+    }
+
+    public DirectScheduleEncoding()
+      : base() {
+      SolutionCreator = new DirectScheduleRandomCreator();
+      DiscoverOperators();
+    }
+
+    #region Operator Discovery
+    private static readonly IEnumerable<Type> encodingSpecificOperatorTypes;
+    static DirectScheduleEncoding() {
+      encodingSpecificOperatorTypes = new List<Type>() {
+          typeof (IDirectScheduleOperator)
+      };
+    }
+    private void DiscoverOperators() {
+      var assembly = typeof(IDirectScheduleOperator).Assembly;
+      var discoveredTypes = ApplicationManager.Manager.GetTypes(encodingSpecificOperatorTypes, assembly, true, false, false);
+      var operators = discoveredTypes.Select(t => (IOperator)Activator.CreateInstance(t));
+      var newOperators = operators.Except(Operators, new TypeEqualityComparer<IOperator>()).ToList();
+
+      ConfigureOperators(newOperators);
+      foreach (var @operator in newOperators)
+        AddOperator(@operator);
+    }
+    #endregion
+
+    public override void ConfigureOperators(IEnumerable<IItem> operators) {
+      base.ConfigureOperators(operators);
+      ConfigureDirectScheduleOperators(operators.OfType<IDirectScheduleOperator>());
+    }
+
+    private void ConfigureDirectScheduleOperators(IEnumerable<IDirectScheduleOperator> operators) {
+      foreach (var @operator in operators)
+        @operator.JobDataParameter.ActualName = JobDataParameter.Name;
+    }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs	(revision 13437)
@@ -23,6 +23,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -33,19 +31,12 @@
   [Item("DirectScheduleRandomCreator", "Creator class used to create schedule encoding objects.")]
   [StorableClass]
-  public class DirectScheduleRandomCreator : ScheduleCreator, IStochasticOperator {
+  public class DirectScheduleRandomCreator : ScheduleCreator, IStochasticOperator, IDirectScheduleOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
     }
-    public IValueLookupParameter<IntValue> JobsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Jobs"]; }
-    }
-    public IValueLookupParameter<IntValue> ResourcesParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
-    }
     public ILookupParameter<ItemList<Job>> JobDataParameter {
       get { return (LookupParameter<ItemList<Job>>)Parameters["JobData"]; }
     }
-
 
     [StorableConstructor]
@@ -60,8 +51,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Jobs", "The number of jobs handled in this problem instance."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("Resources", "The number of resources used in this problem instance."));
       Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Job data taken from the JSSP - Instance."));
-      ScheduleParameter.ActualName = "Schedule";
     }
 
@@ -89,5 +77,6 @@
           new PWREncoding(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue),
           jobData);
-      } catch {
+      }
+      catch {
         throw new Exception("ScheduleRandomCreator needs JobData parameter from a JSSP-Instance to create Schedule-Instances!");
       }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/GTAlgorithmUtils.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/GTAlgorithmUtils.cs	(revision 13436)
+++ 	(revision )
@@ -1,79 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Encodings.ScheduleEncoding {
-  public static class GTAlgorithmUtils {
-
-    public static ItemList<Task> GetEarliestNotScheduledTasks(ItemList<Job> jobData) {
-      ItemList<Task> result = new ItemList<Task>();
-      foreach (Job j in jobData) {
-        foreach (Task t in j.Tasks) {
-          if (!t.IsScheduled) {
-            result.Add(t);
-            break;
-          }
-        }
-      }
-      return result;
-    }
-    public static Task GetTaskWithMinimalEC(ItemList<Task> earliestTasksList, Schedule schedule) {
-      double minEct = double.MaxValue;
-      Task result = null;
-      foreach (Task t in earliestTasksList) {
-        double ect = ComputeEarliestCompletionTime(t, schedule);
-        if (ect < minEct) {
-          result = t;
-          minEct = ect;
-        }
-      }
-      return result;
-    }
-    public static ItemList<Task> GetConflictSetForTask(Task conflictedTask, ItemList<Task> earliestTasksList, ItemList<Job> jobData, Schedule schedule) {
-      ItemList<Task> result = new ItemList<Task>();
-      double conflictedCompletionTime = ComputeEarliestCompletionTime(conflictedTask, schedule);
-      result.Add(conflictedTask);
-      foreach (Task t in earliestTasksList) {
-        if (t.ResourceNr == conflictedTask.ResourceNr) {
-          if (ComputeEarliestStartTime(t, schedule) < conflictedCompletionTime)
-            result.Add(t);
-        }
-      }
-      return result;
-    }
-
-    public static double ComputeEarliestStartTime(Task t, Schedule schedule) {
-      ScheduledTask previousTask = schedule.GetLastScheduledTaskForJobNr(t.JobNr);
-      Resource affectedResource = schedule.Resources[t.ResourceNr];
-      double lastMachineEndTime = affectedResource.TotalDuration;
-      double previousJobTaskEndTime = 0;
-      if (previousTask != null)
-        previousJobTaskEndTime = previousTask.EndTime;
-
-      return Math.Max(previousJobTaskEndTime, lastMachineEndTime);
-    }
-    private static double ComputeEarliestCompletionTime(Task t, Schedule schedule) {
-      return ComputeEarliestStartTime(t, schedule) + t.Duration;
-    }
-  }
-}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Job.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Job.cs	(revision 13436)
+++ 	(revision )
@@ -1,160 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.ComponentModel;
-using System.Text;
-using HeuristicLab.Collections;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Encodings.ScheduleEncoding {
-  [Item("Job", "Represents a composition of tasks that require processing in a scheduling problem.")]
-  [StorableClass]
-  public sealed class Job : Item, INotifyPropertyChanged {
-
-    [Storable(Name = "DueDate")]
-    private double dueDate;
-    public double DueDate {
-      get { return dueDate; }
-      set {
-        if (dueDate == value) return;
-        dueDate = value;
-        OnPropertyChanged("DueDate");
-        OnToStringChanged();
-      }
-    }
-
-    [Storable(Name = "Index")]
-    private int index;
-    public int Index {
-      get { return index; }
-      set {
-        if (index == value) return;
-        index = value;
-        OnPropertyChanged("Index");
-        OnToStringChanged();
-      }
-    }
-
-    [Storable(Name = "Tasks")]
-    private ItemList<Task> tasks;
-    public ItemList<Task> Tasks {
-      get { return tasks; }
-      private set {
-        tasks = value;
-        OnPropertyChanged("Tasks");
-      }
-    }
-
-    [StorableConstructor]
-    private Job(bool deserializing) : base(deserializing) { }
-    private Job(Job original, Cloner cloner)
-      : base(original, cloner) {
-      this.dueDate = original.DueDate;
-      this.index = original.Index;
-      this.tasks = cloner.Clone(original.Tasks);
-      RegisterEventHandlers();
-    }
-    public Job() : this(-1, double.MaxValue) { }
-    public Job(int index, double dueDate)
-      : base() {
-      this.dueDate = dueDate;
-      this.index = index;
-      this.tasks = new ItemList<Task>();
-      RegisterEventHandlers();
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Job(this, cloner);
-    }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      RegisterEventHandlers();
-    }
-
-    private void RegisterEventHandlers() {
-      Tasks.ItemsAdded += TasksOnItemsChanged;
-      Tasks.ItemsRemoved += TasksOnItemsRemoved;
-      Tasks.ItemsReplaced += TasksOnItemsChanged;
-      Tasks.CollectionReset += TasksOnItemsChanged;
-      foreach (var task in Tasks) {
-        task.PropertyChanged += TaskOnPropertyChanged;
-        task.ToStringChanged += TaskOnToStringChanged;
-      }
-    }
-
-    private void TasksOnItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<Task>> e) {
-      foreach (var task in e.OldItems) {
-        task.Value.PropertyChanged -= TaskOnPropertyChanged;
-        task.Value.ToStringChanged -= TaskOnToStringChanged;
-      }
-      foreach (var task in e.Items) {
-        task.Value.PropertyChanged += TaskOnPropertyChanged;
-        task.Value.ToStringChanged += TaskOnToStringChanged;
-      }
-      OnTasksChanged();
-      OnToStringChanged();
-    }
-
-    private void TasksOnItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<Task>> e) {
-      foreach (var task in e.Items) {
-        task.Value.PropertyChanged -= TaskOnPropertyChanged;
-        task.Value.ToStringChanged -= TaskOnToStringChanged;
-      }
-      OnTasksChanged();
-      OnToStringChanged();
-    }
-
-    private void TaskOnPropertyChanged(object sender, EventArgs e) {
-      OnTasksChanged();
-    }
-
-    private void TaskOnToStringChanged(object sender, EventArgs e) {
-      OnToStringChanged();
-    }
-
-    public override string ToString() {
-      var sb = new StringBuilder();
-      sb.Append("Job#" + Index + " [ ");
-      foreach (Task t in Tasks) {
-        sb.Append(t + " ");
-      }
-      sb.Append("{" + DueDate + "} ");
-      sb.Append("]");
-      return sb.ToString();
-    }
-
-    public event EventHandler TasksChanged;
-    private void OnTasksChanged() {
-      var handler = TasksChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event PropertyChangedEventHandler PropertyChanged;
-    private void OnPropertyChanged(string propertyName) {
-      var handler = PropertyChanged;
-      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
-    }
-  }
-}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Manipulators/DirectScheduleManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Manipulators/DirectScheduleManipulator.cs	(revision 13436)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Manipulators/DirectScheduleManipulator.cs	(revision 13437)
@@ -23,4 +23,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -29,11 +30,15 @@
   [StorableClass]
   public abstract class DirectScheduleManipulator : ScheduleManipulator, IDirectScheduleOperator {
+    public ILookupParameter<ItemList<Job>> JobDataParameter {
+      get { return (LookupParameter<ItemList<Job>>)Parameters["JobData"]; }
+    }
 
     [StorableConstructor]
     protected DirectScheduleManipulator(bool deserializing) : base(deserializing) { }
     protected DirectScheduleManipulator(DirectScheduleManipulator original, Cloner cloner) : base(original, cloner) { }
+
     public DirectScheduleManipulator()
       : base() {
-      ScheduleParameter.ActualName = "Schedule";
+      Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Job data taken from the JSSP - Instance."));
     }
 
@@ -42,5 +47,5 @@
     public override IOperation InstrumentedApply() {
       var schedule = ScheduleParameter.ActualValue as Schedule;
-      if (schedule == null) throw new InvalidOperationException("ScheduleEncoding was not found or is not of type Schedule.");
+      if (schedule == null) throw new InvalidOperationException("Schedule was not found or is not of type Schedule.");
       Manipulate(RandomParameter.ActualValue, schedule);
       return base.InstrumentedApply();
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Task.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Task.cs	(revision 13436)
+++ 	(revision )
@@ -1,131 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.ComponentModel;
-using System.Text;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Encodings.ScheduleEncoding {
-  [Item("Task", "Represents a task that has to be scheduled.")]
-  [StorableClass]
-  public class Task : Item, INotifyPropertyChanged {
-
-    [Storable(Name = "TaskNr")]
-    private int taskNr;
-    public int TaskNr {
-      get { return taskNr; }
-      set {
-        bool changed = taskNr != value;
-        taskNr = value;
-        if (changed) {
-          OnPropertyChanged("TaskNr");
-          OnToStringChanged();
-        }
-      }
-    }
-    [Storable(Name = "ResourceNr")]
-    private int resourceNr;
-    public int ResourceNr {
-      get { return resourceNr; }
-      set {
-        bool changed = resourceNr != value;
-        resourceNr = value;
-        if (changed) {
-          OnPropertyChanged("ResourceNr");
-          OnToStringChanged();
-        }
-      }
-    }
-
-    //this has to be exactly the number of the job which the task belongs to
-    //otherwise everything breaks and wrong results are calculated
-    [Storable(Name = "JobNr")]
-    private int jobNr;
-    public int JobNr {
-      get { return jobNr; }
-      set {
-        bool changed = jobNr != value;
-        jobNr = value;
-        if (changed) OnPropertyChanged("JobNr");
-      }
-    }
-
-    [Storable(Name = "Duration")]
-    private double duration;
-    public double Duration {
-      get { return duration; }
-      set {
-        bool changed = duration != value;
-        duration = value;
-        if (changed) OnPropertyChanged("Duration");
-      }
-    }
-
-    [Storable(Name = "IsScheduled")]
-    private bool isScheduled;
-    public bool IsScheduled {
-      get { return isScheduled; }
-      set {
-        bool changed = isScheduled != value;
-        isScheduled = value;
-        if (changed) OnPropertyChanged("IsScheduled");
-      }
-    }
-
-    [StorableConstructor]
-    protected Task(bool deserializing) : base(deserializing) { }
-    protected Task(Task original, Cloner cloner)
-      : base(original, cloner) {
-      this.resourceNr = original.ResourceNr;
-      this.jobNr = original.JobNr;
-      this.duration = original.Duration;
-      this.taskNr = original.TaskNr;
-      this.isScheduled = original.IsScheduled;
-    }
-    public Task() : this(-1, -1, -1, 0) { }
-    public Task(int taskNr, int resNr, int jobNr, double duration)
-      : base() {
-      this.duration = duration;
-      this.resourceNr = resNr;
-      this.jobNr = jobNr;
-      this.taskNr = taskNr;
-      this.isScheduled = false;
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Task(this, cloner);
-    }
-
-    public override string ToString() {
-      StringBuilder sb = new StringBuilder();
-      sb.Append("[" + TaskNr + "," + ResourceNr + "]");
-      return sb.ToString();
-    }
-
-    public event PropertyChangedEventHandler PropertyChanged;
-    protected virtual void OnPropertyChanged(string propertyName) {
-      var handler = PropertyChanged;
-      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
-    }
-  }
-}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Task.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Task.cs	(revision 13437)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Task.cs	(revision 13437)
@@ -0,0 +1,131 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.ComponentModel;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("Task", "Represents a task that has to be scheduled.")]
+  [StorableClass]
+  public class Task : Item, INotifyPropertyChanged {
+
+    [Storable(Name = "TaskNr")]
+    private int taskNr;
+    public int TaskNr {
+      get { return taskNr; }
+      set {
+        bool changed = taskNr != value;
+        taskNr = value;
+        if (changed) {
+          OnPropertyChanged("TaskNr");
+          OnToStringChanged();
+        }
+      }
+    }
+    [Storable(Name = "ResourceNr")]
+    private int resourceNr;
+    public int ResourceNr {
+      get { return resourceNr; }
+      set {
+        bool changed = resourceNr != value;
+        resourceNr = value;
+        if (changed) {
+          OnPropertyChanged("ResourceNr");
+          OnToStringChanged();
+        }
+      }
+    }
+
+    //this has to be exactly the number of the job which the task belongs to
+    //otherwise everything breaks and wrong results are calculated
+    [Storable(Name = "JobNr")]
+    private int jobNr;
+    public int JobNr {
+      get { return jobNr; }
+      set {
+        bool changed = jobNr != value;
+        jobNr = value;
+        if (changed) OnPropertyChanged("JobNr");
+      }
+    }
+
+    [Storable(Name = "Duration")]
+    private double duration;
+    public double Duration {
+      get { return duration; }
+      set {
+        bool changed = duration != value;
+        duration = value;
+        if (changed) OnPropertyChanged("Duration");
+      }
+    }
+
+    [Storable(Name = "IsScheduled")]
+    private bool isScheduled;
+    public bool IsScheduled {
+      get { return isScheduled; }
+      set {
+        bool changed = isScheduled != value;
+        isScheduled = value;
+        if (changed) OnPropertyChanged("IsScheduled");
+      }
+    }
+
+    [StorableConstructor]
+    protected Task(bool deserializing) : base(deserializing) { }
+    protected Task(Task original, Cloner cloner)
+      : base(original, cloner) {
+      this.resourceNr = original.ResourceNr;
+      this.jobNr = original.JobNr;
+      this.duration = original.Duration;
+      this.taskNr = original.TaskNr;
+      this.isScheduled = original.IsScheduled;
+    }
+    public Task() : this(-1, -1, -1, 0) { }
+    public Task(int taskNr, int resNr, int jobNr, double duration)
+      : base() {
+      this.duration = duration;
+      this.resourceNr = resNr;
+      this.jobNr = jobNr;
+      this.taskNr = taskNr;
+      this.isScheduled = false;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Task(this, cloner);
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[" + TaskNr + "," + ResourceNr + "]");
+      return sb.ToString();
+    }
+
+    public event PropertyChangedEventHandler PropertyChanged;
+    protected virtual void OnPropertyChanged(string propertyName) {
+      var handler = PropertyChanged;
+      if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
+    }
+  }
+}
